#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int DEBUG = 1;

/*

<path d="M 43 263 L 77 270   108 266     265  219     306 197 333 191  356  186  376 193
                    394 207   386  242  347 254   330 245   310 237   
                    125 304  103  313    80 316   61  305   46  286   43 263
"/>

*/


double t = 0.5;

/*
void get_control_points(double x0, double y0, double x1, double y1, double x2, double y2,  
    double& p1x, double& p1y, double& p2x, double& p2y, double t)  
{  
    double d01 = sqrt(pow(x1 - x0, 2) + pow(y1 - y0, 2));  
    double d12 = sqrt(pow(x2 - x1, 2) + pow(y2 - y1, 2));  
  
    double fa = t * d01 / (d01 + d12);  
    double fb = t * d12 / (d01 + d12);  
  
    p1x = x1 - fa * (x2 - x0);  
    p1y = y1 - fa * (y2 - y0);  
    p2x = x1 + fb * (x2 - x0);  
    p2y = y1 + fb * (y2 - y0);  
  
    return;  
}  



void get_bezier(double x1, double y1, double x2, double y2, double p12x, double p12y,  
    double p21x, double p21y, std::vector<int>& vec_x, std::vector<int> & vec_y)  
{ 
    int prev_x = (int)round(x1);  
    int prev_y = (int)round(y1);  
    int last_x = (int)round(x2);  
    int last_y = (int)round(y2);  
  
    for (double s = 0.0; s < (1.0 + 0.00001); s += DELTA_S)  
    {  
        double J0 = pow(1 - s, 3);  
        double J1 = pow(1 - s, 2) * s * 3;  
        double J2 = pow(s, 2) * (1 - s) * 3;  
        double J3 = pow(s, 3);  
  
        double ptx = x1 * J0 + p12x * J1 + p21x * J2 + x2 * J3;  
        double pty = y1 * J0 + p12y * J1 + p21y * J2 + y2 * J3;  
  
        int iptx = (int)round(ptx);  
        int ipty = (int)round(pty);  
  
        vec_x.push_back(iptx);  
        vec_y.push_back(ipty);  
    }  
    return;  
}  


*/
void get_control_points(double x0, double y0, double x1, double y1, double x2, double y2,  
    double& p1x, double& p1y, double& p2x, double& p2y, double t)  
{  
    double d01 = sqrt(pow(x1 - x0, 2) + pow(y1 - y0, 2));  
    double d12 = sqrt(pow(x2 - x1, 2) + pow(y2 - y1, 2));  
  
    double fa = t * d01 / (d01 + d12);  
    double fb = t * d12 / (d01 + d12);  
  
    p1x = x1 - fa * (x2 - x0);  
    p1y = y1 - fa * (y2 - y0);  
    p2x = x1 + fb * (x2 - x0);  
    p2y = y1 + fb * (y2 - y0);  
  
    return;  
}  



//18 points
int data_points[] = {
               43,263 , 77 ,270,   108, 266,     265,  219,     
                    306, 197, 333, 191,  356,  186,  376, 193,
                    394, 207,   386,  242,  347, 254,   330, 245,   310, 237,   
                    125, 304,  103,  313,    80, 316,   61,  305,   46,  286,  
               43, 263, 77, 270,
                    -1,-1


};

int control_points[(18+1)*2*2];

int main(int argc, char** argv)
{
   int i; double t1, t2, t3, t4;
   double& p1x = t1;
   double& p1y = t2;
   double& p2x = t3;
   double& p2y = t4;
   double x0, y0,  x1, y1, x2, y2;

    for(i = 0; i < 18; i++)
    {
        x0 = data_points[2*i +0];
        y0 = data_points[2*i +1];
        x1 = data_points[2*i +2];
        y1 = data_points[2*i +3];
        x2 = data_points[2*i +4];
        y2 = data_points[2*i +5];
        if(DEBUG)
        printf("get control points for : %d,%d   %d,%d   %d, %d\n", data_points[2*i +0], data_points[2*i +1], data_points[2*i +2], data_points[2*i +3], \
                                                                    data_points[2*i +4], data_points[2*i +5]);

        get_control_points(    x0, y0,  x1, y1, x2, y2  , p1x, p1y, p2x, p2y,   t);

        control_points[4+4*i + 0] = (int)round(p1x);
        control_points[4+4*i + 1] = (int)round(p1y);
        control_points[4+4*i + 2] = (int)round(p2x);
        control_points[4+4*i + 3] = (int)round(p2y);
         if(DEBUG)
         printf("(%d,%d)  (%d,%d)\n", control_points[4+4*i + 0], control_points[4+4*i + 1],control_points[4+4*i + 2],control_points[4+4*i + 3]);
    }


    if(data_points[2*i +4] == -1  &&  data_points[2*i +5] == -1)
        printf("reach end.\n");
    else
        printf("end error.%d,%d\n", data_points[2*i +0], data_points[2*i +1]);


    if(DEBUG)
    printf("control points are:\n ----------------------\n");
    for(i = 0; i < 18+1; i++)
    {
         if(DEBUG)
         printf("(%d,%d)  (%d,%d)\n", control_points[4*i + 0], control_points[4*i + 1],control_points[4*i + 2],control_points[4*i + 3]);
    }       

    
    for(i = 0; i < 18; i++)
    {
        printf("M %d %d C %d %d   %d %d   %d %d\n", data_points[2*i + 0], data_points[2*i + 1], 
                                                    control_points[4*i+2], control_points[4*i+3],
                                                    control_points[4*i+4], control_points[4*i+5],
                                                    data_points[2*i + 2], data_points[2*i + 3]
                      );
    }
    
     printf("also is as below?----------------\n");

    for(i = 0; i < 18; i++)
    {
        printf(" %d %d   %d %d   %d %d\n", 
                                                    control_points[4*i+2], control_points[4*i+3],
                                                    control_points[4*i+4], control_points[4*i+5],
                                                    data_points[2*i + 2], data_points[2*i + 3]
                      );
    }




   return 0;
}

